extensions [sql array]


globals [

 microgrid
 
 first-node
 second-node
 third-node
 fourth-node
 fifth-node
 sixth-node
 seventh-node
 eighth-node

 modechoice
 housecounter
 IDcounter
 
 temp365
 total-cons-dist-gen
 
 greatest-need
 max-stored
 daily-need
 max-daily
 
 testplot
 testplot2
 
 storage-now
 before-discharge-loss
 surplus
 
 max-peak-shave
 
 total-jan-need
 total-feb-need
 total-mar-need
 total-apr-need
 total-may-need
 total-jun-need
 
 month
 index
 prevmonth
 peakboundaries
 peakboundaries1
 peakboundaries2
 peakboundaries3
 peakboundaries4
 peakboundaries5
 peakboundaries6
 peakboundaries7
 peakboundaries8
 currentpeakboundary
 coeff
 
 nodehourcounter
 averagenodecons
 totalnodecons
 
 node-daily-cons
 node-average-daily
 
 storage
 storagestat
 microgen
 
 hourlynodecons
 hourlynodecons2
 hourlynodecons3
 hourlynodeconscounter
 totalhourlynodecons
 averagehourlynodecons
 
 nodes
 
 totalUserIDs
 
 totalhourcons
 totalhourcounter
 
 dailycons
 macrogrid
 need
 need2
 
 need-dist-gen
 macrogrid-list
 
 prevmacrogrid
 
 current-cons-list
 
 date
 time
 hourlycons
 UserID
 test
 currentUserID
 currentID
 
 averagecons
 counter
 totalcons
 
 lastdayaverage
 lastdayaveragelist
 totaldaycons
 
 hourcounter

 temp3
 genID
 hourlygen
 dailygen
 
 totalstoredenergy
 storedenergylist
 storagestatus
 
 ;;Plotting variables;;
 
 node-macrogrid-cons1
 node-macrogrid-cons2
 
 node-stored1
 node-stored2
 
 plottotal
 plottotal2
 
 plot1
 plot2
 plot3
 plot4
 plot1var
 plot2var
 
 plotgen
]

directed-link-breed [dirlinks dirlink]

to setup
  clear-all
  reset-ticks
  
  setup-database-connection
  setup-mode
  
  setup-generation
  setup-inital-houses
  setup-initial-date-and-time
  
  set greatest-need 0
  set max-stored 0
  set max-daily 0
  set max-peak-shave 0
  
  set prevmonth 1 ; start January
end

to setup-database-connection
  
  sql:configure "defaultconnection" [["host" "localhost"] ["port" 3306] ["user" "root"]
  ["password" "root"] ["database" "demosteinkjer"]]
  
end

to setup-mode
  
  ifelse(Mode = "Solar farm")[
    ;; Solar farm mode
    print "Solar farm mode"
    set modechoice 1
  ]
  [
    ifelse(Mode = "Distributed generation")[
      ;; Distributed generation mode
      print "Distributed generation mode"
      set modechoice 2
    ]
    [
      ;; Island mode
      print "Island mode"
      set modechoice 3
    ]
  ]
  
end

to setup-generation
  
  set dailygen n-values 24 [0]
  set genID n-values 1 [0]
  
  set storedenergylist n-values 20 [0]
  
  set totalstoredenergy 10 * initial-stored-amount
  set storagestatus totalstoredenergy / 10 ;; In per cent
  
  set genID replace-item 0 genID 1 ;; If start date January 1st
  ;set genID replace-item 0 genID 2977 ;; If start date February 1st
  ;set genID replace-item 0 genID 5665 ;; If start date March 1st
  ;set genID replace-item 0 genID 8641 ;; If start date April 1st
  ;set genID replace-item 0 genID 11521 ;; If start date May 1st
  ;set genID replace-item 0 genID 14497 ;; If start date June 1st

  ifelse (modechoice = 1 or modechoice = 3)[
    crt 1 [
      
      set color blue
      set shape "circle"
      set size 4
      set xcor 0
      set ycor 0
      set label "Storage"
      set storage self
      
    ]
    
    crt 1 [
      
      set color green
      set shape "circle"
      set size 3
      set xcor -10
      set ycor 0
      set label "Solar cell farm"
      set microgen self
      set hourlygen 0
      
      ask microgen [
        create-link-with storage
      ]
    ]
  ] 
  [
    set housecounter 0
    while [housecounter < 20][
      ifelse(housecounter = 0 or housecounter = 1)[
        
        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 7 / 38 ))
        set housecounter housecounter + 1
      ]
      [
        ifelse (housecounter = 9 or housecounter = 15)[
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 3 / 38 ))
          set housecounter housecounter + 1
        ]
        [
          ifelse(housecounter = 7 or housecounter = 18)[
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 2 / 38 ))
            set housecounter housecounter + 1
          ]
          [
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 1 / 38 ))
            set housecounter housecounter + 1
          ]
        ]
      ]
    ]
  ]
  
  sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
  set hourlygen sql:fetch-row
  ;print hourlygen
  set dailygen replace-item 0 dailygen read-from-string item 0 hourlygen
  ;print dailygen
  
end

to setup-inital-houses
  
  set totaldaycons 0
  set lastdayaverage 50
  
  set totalUserIDs n-values 20 [0]
  
  set peakboundaries n-values 6 [0]
  
  set hourlycons n-values initial-number-of-homes [0]
  set hourlynodecons n-values 24 [0]
  set hourlynodecons2 n-values 24 [0]
  set hourlynodecons3 n-values 24 [0]
  set hourlynodeconscounter n-values initial-number-of-homes [0]
  set totalhourlynodecons n-values initial-number-of-homes [0]
  set averagehourlynodecons n-values initial-number-of-homes [0]
  
  ;Initializing all UserIDs
  set totalUserIDs [7350049083690884 7350049084530592 7350049084529299 7350049084531155 7350049084529251 7350049084529213 7350049084531209 7350049084529565 7350049084529497 7350049084529459 7350049084529404 7350049084531339 7350049084531292 7350049084531537 7350049084531469 7350049084531346 7350049084530974 7350049084530912 7350049084530813 7350049084530745]
  
  set peakboundaries [1.203 1.198 1.240 1.244 1.292 1.292]
  set peakboundaries1 [1.083 1.078 1.116 1.120 1.163 1.163]
  set peakboundaries2 [0.974 0.970 1.004 1.008 1.047 1.047]
  set peakboundaries3 [0.877 0.873 0.904 0.907 0.942 0.942]
  set peakboundaries4 [0.789 0.786 0.814 0.816 0.848 0.848]
  set peakboundaries5 [0.710 0.707 0.732 0.735 0.763 0.763]
  set peakboundaries6 [0.639 0.637 0.659 0.661 0.687 0.687]
  set peakboundaries7 [0.575 0.573 0.593 0.595 0.618 0.618]
  set peakboundaries8 [0.518 0.516 0.534 0.536 0.556 0.556]
  
  set currentpeakboundary (item 0 peakboundaries)
  set index 0 ;; for position in boundary lists based on month
  
  set currentID n-values initial-number-of-homes [0]
  set currentUserID n-values 1 [0]
  set test n-values 1 [0]
  
  set totalhourcons n-values 24 [0]
  set totalhourcounter n-values 24 [0]
  
  set node-daily-cons n-values 20 [0]
  set node-average-daily n-values 20 [3]
  set macrogrid-list n-values 20 [0]
  set current-cons-list n-values 20 [0]
  
  ;Initialize measurement ID counters to save model setup-time
  ;set currentID [[42732] [4169578] [828310] [5852244] [769377] [633018] [5951536] [1547648] [1416858] [1286261] [1126079] [6261733] [6123584] [6877164] [6663728] [6297209] [5272312] [5083277] [4855812] [4608948]] ; If start Oct 2012
  
  set currentID [[44940] [4171786] [830518] [5854452] [771585] [635226] [5953744] [1549856] [1419066] [1288469] [1128287] [6263941] [6125792] [6879372] [6665936] [6299417] [5274520] [5085485] [4858020] [4611156]] ;If start Jan 2013
  
  ;set currentID [[45684] [4172530] [831262] [5855196] [772329] [635970] [5954488] [1550600] [1419810] [1289213] [1129031] [6264685] [6126536] [6880116] [6666680] [6300161] [5275264] [5086229] [4858764] [4611900]] ; If start February 2013
  
  ;set currentID [[46356] [4173202] [831934] [5855868] [773001] [636642] [5955160] [1551272] [1420482] [1289885] [1129703] [6265357] [6127208] [6880788] [6667352] [6300833] [5275936] [5086901] [4859436] [4612572]] ; If start March 2013
  
  ;set currentID [[47100] [4173946] [832678] [5856612] [773745] [637386] [5955904] [1552016] [1421226] [1290629] [1130447] [6266101] [6127952] [6881532] [6668096] [6301577] [5276680] [5087645] [4860180] [4613316]] ;; If start April 2013
  
  ;set currentID [[47820] [4174666] [833398] [5857332] [774465] [638106] [5956624] [1552736] [1421946] [1291349] [1131167] [6266821] [6128672] [6882252] [6668816] [6302297] [5277400] [5088365] [4860900] [4614036]] ;; If start May 2013
  
  ;set currentID [[48564] [4175410] [834142] [5858076] [775209] [638850] [5957368] [1553480] [1422690] [1292093] [1131911] [6267565] [6129416] [6882996] [6669560] [6303041] [5278144] [5089109] [4861644] [4614780]] ;; If start June 2013
  
  set counter 0
  while [counter < initial-number-of-homes][
    
    set hourlynodeconscounter replace-item counter hourlynodeconscounter hourlynodecons
    set totalhourlynodecons replace-item counter totalhourlynodecons hourlynodecons2
    set averagehourlynodecons replace-item counter averagehourlynodecons hourlynodecons3
    
    set counter counter + 1
  ]

  set hourcounter 0

  set housecounter 0
  
  ifelse(modechoice = 1 or modechoice = 3)[
    while [housecounter < initial-number-of-homes][
      
      make-node
      set housecounter housecounter + 1
      
    ]
  ]
  [
    set counter 0
    while [housecounter < initial-number-of-homes][
      
      make-node-pref
      set housecounter housecounter + 1
      
    ]
  ]
  
  set totalhourcounter replace-item hourcounter totalhourcounter (initial-number-of-homes)
  
  set hourcounter 0
  
end

to make-node
    crt 1
    [
      set color red
      set shape "circle"
      set xcor 0
      set ycor random 10
      set currentUserID replace-item 0 currentUserID (item housecounter totalUserIDs)
      
      ;The initial measurement IDs of all households is preset to reduce model setup time, thus the code below is not necessary to execute
      ;sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000 AND Method = 'ActivePlus'" (currentUserID)
      ;set currentID replace-item housecounter currentID (sql:fetch-row)
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)
      
      set hourlynodecons replace-item 0 hourlynodecons (item housecounter item 0 totalhourlynodecons + item 0 item housecounter hourlycons)
      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons
      
      set hourlynodecons2 replace-item 0 hourlynodecons (item housecounter item 0 hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      set hourlynodecons3 replace-item 0 hourlynodecons ( (item 0 item housecounter totalhourlynodecons) / (item 0 item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3
      
      
      if (choose-house-ID-for-plot1 = item housecounter totalUserIDs)[
        set plot1var housecounter 
        set plot1 item housecounter hourlycons
        set plot3 item housecounter item hourcounter averagehourlynodecons
      ]
      
      if (choose-house-ID-for-plot2 = item housecounter totalUserIDs)[
        set plot2var housecounter 
        set plot2 item 0 item housecounter hourlycons
        set plot4 item housecounter item hourcounter averagehourlynodecons
      ]
      create-link-with storage [ set color grey ]
      fd 6
      
    ]
  
end

to make-node-pref

  crt 1
    [
      set color red
      set shape "circle"
      ;set xcor 0
      ;set ycor random 10
      set currentUserID replace-item 0 currentUserID (item housecounter totalUserIDs)
      
      ;The initial measurement IDs of all households is preset to reduce model setup time, thus the code below is not necessary to execute
      ;sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000 AND Method = 'ActivePlus'" (currentUserID)
      ;set currentID replace-item housecounter currentID (sql:fetch-row)
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      ;set label currentUserID
      
      set node-daily-cons replace-item housecounter node-daily-cons (item housecounter node-daily-cons + item 0 item housecounter hourlycons)
      ;print node-daily-cons
      
      set current-cons-list replace-item housecounter current-cons-list (item 0 item housecounter hourlycons)
      set testplot item 2 current-cons-list
      
      set macrogrid-list replace-item housecounter macrogrid-list (item 0 item housecounter hourlycons)
      ;print macrogrid-list     
      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)
      ;print totalhourcons
      
      set hourlynodecons replace-item 0 hourlynodecons (item housecounter item 0 totalhourlynodecons + item 0 item housecounter hourlycons)
      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons
      ;print totalhourlynodecons
      
      set hourlynodecons2 replace-item 0 hourlynodecons (item housecounter item 0 hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      ;print hourlynodeconscounter
      
      set hourlynodecons3 replace-item 0 hourlynodecons ( (item 0 item housecounter totalhourlynodecons) / (item 0 item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3
      ;print averagehourlynodecons
      
      set hourcounter 1
      
      if (choose-house-ID-for-plot1 = item housecounter totalUserIDs)[
        set plot1var housecounter 
        set plot1 item housecounter hourlycons
        set plot3 item housecounter item hourcounter averagehourlynodecons
      ]
      
      if (choose-house-ID-for-plot2 = item housecounter totalUserIDs)[
        set plot2var housecounter 
        set plot2 item 0 item housecounter hourlycons
        set plot4 item housecounter item hourcounter averagehourlynodecons
      ]
      
      ifelse(housecounter = 0)[
        set first-node self
        set size 6
        set xcor -5
        set ycor 0
      ]
      [
        ifelse(housecounter = 1)[
          create-dirlink-from first-node [ set color grey ]
          create-dirlink-to first-node [ set color grey ]
          set second-node self
          set size 6
          set xcor 5
          set ycor 0
        ]
        [
          ifelse(housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6)[
            create-dirlink-from first-node [ set color grey ]
            create-dirlink-to first-node [ set color grey ]
            set size 1
            ifelse(housecounter = 2)[
              set xcor -1
              set ycor -5
            ]
            [
              ifelse(housecounter = 3)[
                set xcor -6
                set ycor -6
              ]
              [
                ifelse(housecounter = 4)[
                  set xcor -11
                  set ycor -2
                ]
                [
                  ifelse(housecounter = 5)[
                    set xcor -12
                    set ycor 4
                  ]
                  [
                    set xcor 0
                    set ycor 4
                  ]
                ]
              ]
            ]
          ]
          [
            ifelse(housecounter = 7)[
              create-dirlink-to first-node [ set color grey ]
              create-dirlink-from first-node [ set color grey ]
              set size 2
              set third-node self
              set xcor -5
              set ycor 7
            ]
            [
              ifelse(housecounter = 8)[
                create-dirlink-from third-node [ set color grey ]
                create-dirlink-to third-node [ set color grey ]
                set size 1
                set xcor -6
                set ycor 10
              ]
              [ 
                ifelse(housecounter = 9)[
                  create-dirlink-from second-node [ set color grey ]
                  create-dirlink-to second-node [ set color grey ]
                  set size 3
                  set fourth-node self
                  set xcor 6
                  set ycor 6
                ]
                [
                  ifelse(housecounter = 10 or housecounter = 11)[
                    create-dirlink-from fourth-node [ set color grey ]
                    create-dirlink-to fourth-node [ set color grey ]
                    set size 1
                    ifelse(housecounter = 10)[
                      set xcor 8
                      set ycor 9
                    ]
                    [
                      set xcor 4
                      set ycor 9
                    ]
                  ]
                  [
                    ifelse(housecounter = 12 or housecounter = 13 or housecounter = 14)[
                      create-dirlink-from second-node [ set color grey ]
                      create-dirlink-to second-node [ set color grey ]
                      set size 1
                      ifelse(housecounter = 12)[
                        set xcor 11
                        set ycor 2
                      ]
                      [
                        ifelse(housecounter = 13)[
                          set xcor 12
                          set ycor 0
                        ]
                        [
                          set xcor 11
                          set ycor -2
                        ]
                      ]
                      
                    ]
                    [
                      ifelse(housecounter = 15)[
                        create-dirlink-from second-node [ set color grey ]
                        create-dirlink-to second-node [ set color grey ]

                        set size 3
                        set fifth-node self
                        set xcor 4
                        set ycor -7
                      ]
                      [
                        ifelse(housecounter = 16 or housecounter = 17)[
                          create-dirlink-from fifth-node [ set color grey ]
                          create-dirlink-to fifth-node [ set color grey ]
                          set size 1
                          ifelse(housecounter = 16)[
                            set xcor 3
                            set ycor -10
                          ]
                          [
                            set xcor 5
                            set ycor -10
                          ]
                        ]
                        [
                          ifelse(housecounter = 18)[
                            create-dirlink-from second-node [ set color grey ]
                            create-dirlink-to second-node [ set color grey ]
                            set size 2
                            set sixth-node self
                            set xcor 0
                            set ycor -7
                          ]
                          [
                            ifelse(housecounter = 19)[
                              create-dirlink-from sixth-node [ set color grey ]
                              create-dirlink-to sixth-node [ set color grey ]
                              set size 1
                              set xcor -3
                              set ycor -8
                            ]
                            [
                              print "Error: housecounter > number of homes"
                            ]
                          ]
                        ]
                      ] 
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
      
    ]

end

to setup-initial-date-and-time
  sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000" [7350049083690884]
  set IDcounter sql:fetch-row
  
  sql:exec-query "SELECT Date FROM consumption WHERE ID = ?" (IDcounter)
  set date sql:fetch-row
  sql:exec-query "SELECT Time FROM consumption WHERE ID = ?" (IDcounter)
  set time sql:fetch-row
  
end

to go
  if ticks >= (number-of-days-for-simulation * 24 - 1) [stop]
  
  update-consumption
  update-total-consumption
  update-date-and-time
  update-generation
  
  tick
end

to update-date-and-time
  set IDcounter replace-item 0 IDcounter (item 0 IDcounter + 1)
  sql:exec-query "SELECT Date FROM consumption WHERE ID = ?" (IDcounter)
  set date sql:fetch-row
  
  set month item 6 item 0 date
  if (month != prevmonth)[
    set prevmonth month
    set index read-from-string month
    set index index - 1
    set currentpeakboundary (item index peakboundaries)
  ]

  
  sql:exec-query "SELECT Time FROM consumption WHERE ID = ?" (IDcounter)
  set time sql:fetch-row
  
end

to update-consumption
  
    set housecounter 0
    let temp n-values 1 [0]
    let temp2 n-values 1 [0]
  
  while [housecounter < initial-number-of-homes][
      
      set temp replace-item 0 temp (item housecounter currentID)
      set temp replace-item 0 temp (item 0 item 0 temp + 1)
      set currentID replace-item housecounter currentID temp
      
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      
      set node-daily-cons replace-item housecounter node-daily-cons (item housecounter node-daily-cons + item 0 item housecounter hourlycons)

      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)

      
      set hourlynodecons (item housecounter totalhourlynodecons)

      set hourlynodecons replace-item hourcounter hourlynodecons (item hourcounter item housecounter totalhourlynodecons + item 0 item housecounter hourlycons)

      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons

     
      set hourlynodecons2 (item housecounter hourlynodeconscounter)
      set hourlynodecons2 replace-item hourcounter hourlynodecons2 (item hourcounter item housecounter hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      
      set hourlynodecons3 (item housecounter averagehourlynodecons)
      set hourlynodecons3 replace-item hourcounter hourlynodecons3 ( (item hourcounter item housecounter totalhourlynodecons) / (item hourcounter item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3

      
      if (plot1var = housecounter)[ 
        set plot1 item 0 item housecounter hourlycons
        set plot3 item hourcounter item housecounter averagehourlynodecons
      ]
      
      if (plot2var = housecounter)[
        set plot2 item 0 item housecounter hourlycons
        set plot4 item hourcounter item housecounter averagehourlynodecons
      ]
      
      set housecounter housecounter + 1
  ]
  
  set totalhourcounter replace-item hourcounter totalhourcounter (item hourcounter totalhourcounter + initial-number-of-homes)
    
    
  set housecounter 0
  set totalcons 0
  set macrogrid 0
  set total-cons-dist-gen 0
  
  while[housecounter < initial-number-of-homes][
    
    set temp2 (item housecounter hourlycons)
    set totalcons totalcons + (item 0 temp2)
    
    set housecounter housecounter + 1
  ]  

  ifelse(modechoice = 1)[
    peakshaving-solar-farm
  ]
  [
    ifelse(modechoice = 2)[
      peakshaving-dist-gen
    ]
    [
      island-mode ;;No peakshaving
    ]
  ]


  
  set averagecons totalcons / initial-number-of-homes
  
  set totaldaycons totaldaycons + totalcons
end

to peakshaving-solar-farm
  
  ifelse (totalstoredenergy > 1000)[
    
    set currentpeakboundary (item index peakboundaries8)
    set need2 totalstoredenergy - 1000
    set totalstoredenergy totalstoredenergy - need2
    
  ]
  [
    set need2 0
    ifelse (totalstoredenergy > 900)[
      
      set currentpeakboundary (item index peakboundaries8)
      
    ]
    [
      
      ifelse (totalstoredenergy > 800)[
        
        set currentpeakboundary (item index peakboundaries7)
        
      ]
      [
        
        ifelse (totalstoredenergy > 700)[
          
          set currentpeakboundary (item index peakboundaries6)
          
        ]
        [
          
          ifelse (totalstoredenergy > 600)[
            
            set currentpeakboundary (item index peakboundaries5)
            
          ]
          [
            
            ifelse (totalstoredenergy > 500)[
              
              set currentpeakboundary (item index peakboundaries4)
              
            ]
            [
              ifelse (totalstoredenergy > 400)[
                
                set currentpeakboundary (item index peakboundaries3)
                
              ]
              [
                ifelse (totalstoredenergy > 300)[
                  
                  set currentpeakboundary (item index peakboundaries2)
                  
                ]
                [
                  ifelse (totalstoredenergy > 200)[
                    
                    set currentpeakboundary (item index peakboundaries1)
                    
                  ]
                  [
                    set currentpeakboundary (item index peakboundaries)
                  ]
                ]
              ] 
            ]
          ]
        ]
      ]
    ]
  ]
  
  
  
  ifelse (totalcons > currentpeakboundary * lastdayaverage)[
    
    set need totalcons - (currentpeakboundary * lastdayaverage)
    
    ifelse (totalstoredenergy > 200 and totalcons < (item index peakboundaries) * lastdayaverage )[
      
      ifelse (need > totalstoredenergy - 200)[
        
        set need totalstoredenergy - 200
        set totalstoredenergy totalstoredenergy - need
        set macrogrid totalcons - need
        
      ]
      [
        
        set totalstoredenergy totalstoredenergy - need
        set need need + need2
        set macrogrid totalcons - need 
        
      ]
    ]  
    [ 
      set need totalcons - (currentpeakboundary * lastdayaverage)
      
      ifelse (totalstoredenergy > 0)[
        
        ifelse (need > totalstoredenergy)[
          set need totalstoredenergy
          set totalstoredenergy totalstoredenergy - need
          set macrogrid totalcons - need
          
        ]
        [
          set totalstoredenergy totalstoredenergy - need
          set need need + need2
          set macrogrid totalcons - need
        ]
        
      ]
      [
        set macrogrid totalcons
        set need 0
      ]
      
    ]
  ]
  [
    set macrogrid totalcons
    set need 0
  ]
  
end

to peakshaving-dist-gen
  
  set need-dist-gen 0
  set housecounter 0
  set currentpeakboundary (item index peakboundaries)
  
  ifelse (storagestatus > 90)[
    
    set currentpeakboundary (item index peakboundaries8)
    
  ]
  [
    
    ifelse (storagestatus > 80)[
      
      set currentpeakboundary (item index peakboundaries7)
      
    ]
    [
      
      ifelse (storagestatus > 70)[
        
        set currentpeakboundary (item index peakboundaries6)
        
      ]
      [
        
        ifelse (storagestatus > 60)[
          
          set currentpeakboundary (item index peakboundaries5)
          
        ]
        [
          
          ifelse (storagestatus > 50)[
            
            set currentpeakboundary (item index peakboundaries4)
            
          ]
          [
            ifelse (storagestatus > 40)[
              
              set currentpeakboundary (item index peakboundaries3)
              
            ]
            [
              ifelse (storagestatus > 30)[
                
                set currentpeakboundary (item index peakboundaries2)
                
              ]
              [
                ifelse (storagestatus > 20)[
                  
                  set currentpeakboundary (item index peakboundaries1)
                  
                ]
                [
                  set currentpeakboundary (item index peakboundaries)
                ]
              ]
            ] 
          ]
        ]
      ]
    ]
  ]
  
  
  while [housecounter < initial-number-of-homes][
    set current-cons-list replace-item housecounter current-cons-list (item 0 item housecounter hourlycons)
    set testplot item 2 current-cons-list 
    ifelse(housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6)[
      ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
        set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
        ifelse(need-dist-gen < item housecounter storedenergylist)[
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
        ]
        [
          ifelse(need-dist-gen < item 0 storedenergylist)[
            set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
          ]
          [
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
          ]
        ]
      ]
      [
        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
        ;;no peak shaving needed
      ]
      set testplot2 item 2 macrogrid-list
      set housecounter housecounter + 1
    ]
    [
      ifelse(housecounter = 7)[
        ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
          set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
          ifelse(need-dist-gen < item housecounter storedenergylist)[
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
          ]
          [
            ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
            ifelse(need-dist-gen < item 0 storedenergylist)[
              set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
            ]
            [
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
            ]
          ]
        ]
        [
        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
        ;;no peak shaving
        ]
        set housecounter housecounter + 1
      ]
      [
        ifelse(housecounter = 8)[
          ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
            set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
            ifelse(need-dist-gen < item housecounter storedenergylist)[
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
            ]
            [
              ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
              ifelse(need-dist-gen < item 7 storedenergylist)[
                set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist - need-dist-gen)
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
              ]
              [
                ifelse(need-dist-gen < item 0 storedenergylist)[
                  set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
                  set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist + need-dist-gen)
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                ]
              ]
            ]
          ]
          [
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
            ;;no peak shaving needed
          ]
          set housecounter housecounter + 1
        ]
        [
          ifelse(housecounter = 0)[
            ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
              set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
              ifelse(need-dist-gen < item housecounter storedenergylist)[
                set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
              ]
              [
                ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                ifelse(need-dist-gen < item 1 storedenergylist)[
                  set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                ]
              ]
            ]
            [
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
              ;;no peak shaving needed
            ]
            set housecounter housecounter + 1
          ]
          [
            ifelse(housecounter = 9 or housecounter = 12 or housecounter = 13 or housecounter = 14 or housecounter = 15 or housecounter = 18)[
              ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                ifelse(need-dist-gen < item housecounter storedenergylist)[
                  set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                ]
                [
                  ifelse(need-dist-gen < item 1 storedenergylist)[
                    set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                  ]
                  [
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                  ]
                ]
              ]
              [
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                ;;no peak shaving needed
              ]
              set housecounter housecounter + 1
            ]
            [
              ifelse(housecounter = 10 or housecounter = 11)[
                ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                  set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                  ifelse(need-dist-gen < item housecounter storedenergylist)[
                    set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                  ]
                  [
                    ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                    ifelse(need-dist-gen < item 9 storedenergylist)[
                      set storedenergylist replace-item 9 storedenergylist (item 9 storedenergylist - need-dist-gen)
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                    ]
                    [
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                    ]
                  ]
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                  ;;no peak shaving needed
                ]
                set housecounter housecounter + 1
              ]
              [
                ifelse(housecounter = 16 or housecounter = 17)[
                  ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                    set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                    ifelse(need-dist-gen < item housecounter storedenergylist)[
                      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                    ]
                    [
                      ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                      ifelse(need-dist-gen < item 15 storedenergylist)[
                        set storedenergylist replace-item 15 storedenergylist (item 15 storedenergylist - need-dist-gen)
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                      ]
                      [
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                      ]
                    ]
                  ]
                  [
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                    ;;no peak shaving needed
                  ]
                  set housecounter housecounter + 1 
                ]
                [
                  ifelse(housecounter = 19)[
                    ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                      set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                      ifelse(need-dist-gen < item housecounter storedenergylist)[
                        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                      ]
                      [
                        ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                        ifelse(need-dist-gen < item 18 storedenergylist)[
                          set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist - need-dist-gen)
                          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                        ]
                        [
                          ifelse(need-dist-gen < item 1 storedenergylist)[
                            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                            set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist + need-dist-gen)
                          ]
                          [
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                          ]
                        ]
                      ]
                    ]
                    [
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                      ;;no peak shaving
                    ]
                    set housecounter housecounter + 1
                  ]
                  [
                    ifelse(housecounter = 1)[
                      ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                        set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                        ifelse(need-dist-gen < item housecounter storedenergylist)[
                          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                        ]
                        [
                          ifelse(need-dist-gen < item 0 storedenergylist)[
                            set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                          ]
                          [
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                          ]
                        ]
                      ]
                      [
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                        ;;no peak shaving
                      ]
                      set housecounter housecounter + 1
                    ]
                    [
                      print "Error: housecounter > number of homes"
                      print housecounter
                      ;set housecounter housecounter + 1
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
    ]
  ]
  set housecounter 0
  while [housecounter < initial-number-of-homes][
    set macrogrid macrogrid + (item housecounter macrogrid-list)
    set total-cons-dist-gen total-cons-dist-gen + (item housecounter current-cons-list)
    set housecounter housecounter + 1
  ]
  
  set node-macrogrid-cons1 item plot1var macrogrid-list
  set node-macrogrid-cons2 item plot2var macrogrid-list
  
end

to island-mode
  
  set macrogrid totalcons
  
  ifelse (totalstoredenergy > 1000 and External-supply)[
    
    set currentpeakboundary (item index peakboundaries)
    set need totalstoredenergy - 1000
    set totalstoredenergy totalstoredenergy - need
    set macrogrid macrogrid - need
    
  ]
  [ 
    ifelse (not External-supply)[
      set macrogrid 0
      ifelse (totalstoredenergy > totalcons)[
        set totalstoredenergy totalstoredenergy - totalcons
        set microgrid totalcons
      ]
      [
        ifelse (totalstoredenergy > 10)[
          set need totalstoredenergy
          set totalstoredenergy totalstoredenergy - need
          set microgrid need
        ]
        [
          set microgrid 0
        ]
      ]
    ]
    [
      set macrogrid macrogrid
      set microgrid 0
    ]
  ]
  
end

to update-total-consumption
  set plottotal (item hourcounter totalhourcons) / (item hourcounter totalhourcounter)
  set plottotal2 (item hourcounter totalhourcons)
  
  ifelse (hourcounter = 23)[
    set hourcounter 0
    
    set dailygen n-values 24 [0]
    set dailycons 0  
    
    ifelse(modechoice = 1)[
      set daily-need daily-need + need
    ]
    [
      ifelse(modechoice = 2)[
        set daily-need daily-need + (total-cons-dist-gen - macrogrid)
      ]
      [
        ;;Do nothing
      ]
    ]
    
    
    if (daily-need > max-daily)[
      set max-daily daily-need      
    ]
    
    set daily-need 0
    
    if(modechoice = 2)[
      
      set housecounter 0
      while [housecounter < initial-number-of-homes][
        
        set node-average-daily replace-item housecounter node-average-daily (item housecounter node-daily-cons / 24)
        set node-daily-cons replace-item housecounter node-daily-cons 0
        set housecounter housecounter + 1
        
      ]
    ]

    set lastdayaverage totaldaycons / 24
    set totaldaycons 0
  ]
  [
    
    ifelse(modechoice = 1)[
      set daily-need daily-need + need
    ]
    [
      ifelse(modechoice = 2)[
        set daily-need daily-need + (total-cons-dist-gen - macrogrid)
      ]
      [
        ;;Do nothing
      ]
    ]
    set hourcounter hourcounter + 1
  ]
  
end

to update-generation
  
  ifelse(modechoice = 1 or modechoice = 3)[
    generation-solar-farm-or-island-mode
  ]
  [
    generation-dist-gen-mode
  ]
  

end

to generation-solar-farm-or-island-mode
  
  repeat 4[
    set genID replace-item 0 genID (item 0 genID + 1)
    sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
    set hourlygen sql:fetch-row
    set dailygen replace-item hourcounter dailygen (item hourcounter dailygen + read-from-string item 0 hourlygen)
    set before-discharge-loss read-from-string item 0 hourlygen
    
    ;;Updating storage status and accounting for 10 % discharge loss
    set totalstoredenergy totalstoredenergy + (before-discharge-loss * 0.9)
    if(totalstoredenergy > max-stored and index = 0)[
      set max-stored totalstoredenergy
    ]
    set storagestatus totalstoredenergy / 10
    set plotgen item hourcounter dailygen
  ]
  
end

to generation-dist-gen-mode
  
  repeat 4[
    set genID replace-item 0 genID (item 0 genID + 1)
    ;print genID
    sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
    set hourlygen sql:fetch-row
    ;print hourlygen
    set dailygen replace-item hourcounter dailygen (item hourcounter dailygen + read-from-string item 0 hourlygen)
    ;set totalstoredenergy totalstoredenergy + read-from-string item 0 hourlygen
    ;set storagestatus totalstoredenergy / 10
    set plotgen item hourcounter dailygen
    ;print dailygen
  ]
  
  set housecounter 0
  set storage-now 0
  set surplus 0
  while [housecounter < 20][
    ifelse(housecounter = 0 or housecounter = 1)[
      
      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 7 / 38 ) * 0.9)
      ;set housecounter housecounter + 1
      ifelse(housecounter = 1 and (item 0 storedenergylist > item 1 storedenergylist))[
        set surplus (item 0 storedenergylist) - (item 1 storedenergylist)
        set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - surplus)
        set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus / 2)
        set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus / 2)
      ]
      [
        ifelse(housecounter = 1 and (item 1 storedenergylist > item 0 storedenergylist))[
          set surplus (item 1 storedenergylist) - (item 0 storedenergylist)
          set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - surplus)
          set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus / 2)
          set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus / 2)        
        ]
        [
          
        ]
      ]
    ]
    [
      ifelse(housecounter = 7 or housecounter = 18)[
        
        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 3 / 38 ) * 0.9)
        ;set housecounter housecounter + 1
        ifelse(housecounter = 7 and (item housecounter storedenergylist > 20))[
          set surplus (item housecounter storedenergylist) - 20
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
          set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus) 
        ]
        [
          if(housecounter = 18 and (item housecounter storedenergylist > 20))[
            set surplus (item housecounter storedenergylist) - 20
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus) 
          ]
        ]
      ]
      [
        ifelse(housecounter = 9 or housecounter = 15)[
          
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 2 / 38 ) * 0.9)
          ;set housecounter housecounter + 1
          ifelse(housecounter = 9 and (item housecounter storedenergylist > 30))[
            set surplus (item housecounter storedenergylist) - 30
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus)
          ]
          [
            if(housecounter = 15 and (item housecounter storedenergylist > 30))[
              set surplus (item housecounter storedenergylist) - 30
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
              set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus) 
            ]
          ]
        ]
        [
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 1 / 38 ) * 0.9)
          ;set housecounter housecounter + 1
          ifelse((housecounter = 11 or housecounter = 10) and (item housecounter storedenergylist > 10))[
            set surplus (item housecounter storedenergylist) - 10
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 9 storedenergylist (item 9 storedenergylist + surplus)
          ]
          [
            ifelse((housecounter = 12 or housecounter = 13 or housecounter = 14) and (item housecounter storedenergylist > 10))[
              set surplus (item housecounter storedenergylist) - 10
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
              set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus)                
            ]
            [
              ifelse((housecounter = 16 or housecounter = 17) and (item housecounter storedenergylist > 10))[
                set surplus (item housecounter storedenergylist) - 10
                set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                set storedenergylist replace-item 15 storedenergylist (item 15 storedenergylist + surplus) 
              ]
              [
                ifelse(housecounter = 19 and (item housecounter storedenergylist > 10))[
                  set surplus (item housecounter storedenergylist) - 10
                  set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                  set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist + surplus) 
                ]
                [
                  ifelse((housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6) and (item housecounter storedenergylist > 10))[
                    set surplus (item housecounter storedenergylist) - 10
                    set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                    set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus) 
                  ]
                  [
                    ifelse(housecounter = 8 and (item housecounter storedenergylist > 10))[
                      set surplus (item housecounter storedenergylist) - 10
                      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                      set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist + surplus)
                    ]
                    [
                      ;;Do nothing 
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
    ]
    set storage-now storage-now + (item housecounter storedenergylist)
    set housecounter housecounter + 1 
  ]
  
set totalstoredenergy storage-now
set storagestatus totalstoredenergy / 10

set node-stored1 item plot1var storedenergylist
set node-stored2 item plot2var storedenergylist
  
  if(totalstoredenergy > max-stored and index = 5)[
    set max-stored totalstoredenergy
    print "New max amount"
    print max-stored
    print "date"
    print date
  ]
  
end
@#$#@#$#@
GRAPHICS-WINDOW
238
10
677
470
16
16
13.0
1
10
1
1
1
0
1
1
1
-16
16
-16
16
0
0
1
ticks
30.0

BUTTON
59
23
122
56
setup
setup
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
37
190
217
223
initial-number-of-homes
initial-number-of-homes
0
20
20
1
1
NIL
HORIZONTAL

SLIDER
13
328
231
361
number-of-days-for-simulation
number-of-days-for-simulation
0
179
179
1
1
NIL
HORIZONTAL

MONITOR
46
603
128
648
NIL
date
17
1
11

BUTTON
141
23
204
56
NIL
go\n
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
0

MONITOR
129
603
209
648
NIL
time
17
1
11

PLOT
677
10
944
212
Total Microgrid Consumption pattern
Time [hour]
Consumption [kW]
0.0
23.0
0.0
20.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot totalcons"

CHOOSER
43
231
215
276
choose-house-ID-for-plot1
choose-house-ID-for-plot1
7350049083690884 7350049084530592 7350049084529299 7350049084531155 7350049084529251 7350049084529213 7350049084531209 7350049084529565 7350049084529497 7350049084529459 7350049084529404 7350049084531339 7350049084531292 7350049084531537 7350049084531469 7350049084531346 7350049084530974 7350049084530912 7350049084530813 7350049084530745
16

CHOOSER
44
276
215
321
choose-house-ID-for-plot2
choose-house-ID-for-plot2
7350049083690884 7350049084530592 7350049084529299 7350049084531155 7350049084529251 7350049084529213 7350049084531209 7350049084529565 7350049084529497 7350049084529459 7350049084529404 7350049084531339 7350049084531292 7350049084531537 7350049084531469 7350049084531346 7350049084530974 7350049084530912 7350049084530813 7350049084530745
7

PLOT
683
513
976
712
Chosen UserIDs' consumption pattern (1)
Time [hour]
Consumption [kW]
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot plot1"

PLOT
684
721
977
928
Chosen UserIDs' consumption pattern (2)
Time [hour]
Consumption [kW]
0.0
10.0
0.0
1.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot plot2"

PLOT
979
517
1263
708
Overall daily average consumption in (1)
Time [hour]
Consumption [kW]
0.0
23.0
0.0
1.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plot3"

PLOT
980
718
1265
927
Overall daily average consumption in (2)
Time [hour]
Consumption [kW]
0.0
23.0
0.0
1.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plot4"

PLOT
1269
519
1566
707
Current daily consumption (1)
Time [hour]
Consumption [kW]
0.0
23.0
0.0
1.0
true
false
"" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plot1"
"pen-1" 1.0 0 -2674135 true "" "plotxy hourcounter node-macrogrid-cons1"

PLOT
1268
721
1563
930
Current daily consumption (2)
Time [hour]
Consumption [kW]
0.0
23.0
0.0
1.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plot2"
"pen-1" 1.0 0 -2674135 true "" "plotxy hourcounter node-macrogrid-cons2"

PLOT
1273
213
1857
507
Daily microgrid consumption (Island mode)
Time [hours]
Consumption  [kW]
0.0
23.0
30.0
80.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]\nif (modechoice = 1 or modechoice = 2)[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter totalcons"
"pen-1" 1.0 0 -2674135 true "" "plotxy hourcounter macrogrid"
"pen-2" 1.0 0 -13840069 true "" "plotxy hourcounter microgrid"

PLOT
945
10
1342
209
Aggregated daily microgrid consumption pattern
Time [hour]
Consumption [kW]
0.0
23.0
0.0
0.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plottotal2"

PLOT
1347
10
1851
208
Total daily solar generation
Time [hour]
Generation [kW]
0.0
23.0
0.0
10.0
true
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter plotgen"

MONITOR
412
471
677
516
Total amount of stored microgrid energy in %
storagestatus
17
1
11

MONITOR
238
471
411
516
Daily consumed energy
dailycons
17
1
11

PLOT
239
517
677
771
Status of BES system
Time [hour]
Storage in % of capacity
0.0
4300.0
0.0
100.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot storagestatus"

CHOOSER
44
68
216
113
Mode
Mode
"Solar farm" "Distributed generation" "Island"
0

SWITCH
55
517
197
550
external-supply
external-supply
0
1
-1000

SLIDER
39
371
219
404
initial-stored-amount
initial-stored-amount
0
100
20
1
1
NIL
HORIZONTAL

PLOT
678
213
1268
507
Daily microgrid consumption (solar farm and distributed generation mode)
Time [hour]
Consumption [kW]
0.0
23.0
0.0
80.0
false
false
"clear-plot" "if (hourcounter = 0 AND (ticks < number-of-days-for-simulation * 24 - 1))[clear-plot]\nif (modechoice = 3)[clear-plot]"
PENS
"default" 1.0 0 -16777216 true "" "plotxy hourcounter totalcons"
"pen-1" 1.0 0 -2674135 true "" "plotxy hourcounter macrogrid"

TEXTBOX
56
147
206
175
General settings (regardless of mode)
11
0.0
1

TEXTBOX
58
486
208
504
Settings for island mode only
11
0.0
1

TEXTBOX
828
579
978
597
NIL
11
0.0
1

PLOT
1573
519
1847
709
Storage status in (1)
Time [hour]
Storage [kW]
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot node-stored1"

PLOT
1571
721
1848
933
Storage status in (2)
Time [hour]
Storage [kW]
0.0
10.0
0.0
10.0
true
false
"" ""
PENS
"default" 1.0 0 -16777216 true "" "plot node-stored2"

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.0.5
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
0
@#$#@#$#@
