extensions [sql array]


globals [ microgrid first-node second-node third-node fourth-node fifth-node sixth-node seventh-node eighth-node modechoice housecounter IDcounter temp365 total-cons-dist-gen greatest-need max-stored daily-need max-daily testplot testplot2  storage-now before-discharge-loss surplus month index prevmonth peakboundaries peakboundaries1 peakboundaries2 peakboundaries3 peakboundaries4 peakboundaries5 peakboundaries6 peakboundaries7 peakboundaries8 currentpeakbounday coeff nodehourcounter averagenodecons totalnodecons node-daily-cons node-average-daily  storage storagestat microgen hourlynodecons hourlynodecons2 hourlynodecons3 hourlynodeconscounter totalhourlynodecons averagehourlynodecons nodes totalUserIDs totalhourcons totalhourcounter dailycons macrogrid need need2 need-dist-gen macrogrid-list prevmacrogrid current-cons-list date time hourlycons UserID test currentUserID currentID averagecons counter totalcons lastdayaverage lastdayaveragelist totaldaycons hourcounter temp3 genID hourlygen dailygen totalstoredenergy storedenergylist storagestatus node-macrogrid-cons1 node-macrogrid-cons2 node-stored1 node-stored2 plottotal plottotal2 plot1 plot2 plot3 plot4 plot1var plot2var plotgen
]

directed-link-breed [dirlinks dirlink]

to setup
  clear-all
  reset-ticks
  
  setup-database-connection
  setup-mode
  
  setup-generation
  setup-inital-houses
  setup-initial-date-and-time
  
  set prevmonth 1 ; start January
end

to setup-database-connection
  
  sql:configure "defaultconnection" [["host" "localhost"] ["port" 3306] ["user" "root"]
  ["password" "root"] ["database" "demosteinkjer"]]
  
end

to setup-mode
  
  ifelse(Mode = "Solar farm")[
    ;; Solar farm mode
    print "Solar farm mode"
    set modechoice 1
  ]
  [
    ifelse(Mode = "Distributed generation")[
      ;; Distributed generation mode
      print "Distributed generation mode"
      set modechoice 2
    ]
    [
      ;; Island mode
      print "Island mode"
      set modechoice 3
    ]
  ]
  
end

to setup-generation
  
  set dailygen n-values 24 [0]
  set genID n-values 1 [0]
  
  set storedenergylist n-values 20 [0]
  
  set totalstoredenergy 10 * initial-stored-amount
  set storagestatus totalstoredenergy / 10 ;; In per cent
  
  set genID replace-item 0 genID 1 ;; If start date January 1st
  ;set genID replace-item 0 genID 2977 ;; If start date February 1st
  ;set genID replace-item 0 genID 5665 ;; If start date March 1st
  ;set genID replace-item 0 genID 8641 ;; If start date April 1st
  ;set genID replace-item 0 genID 11521 ;; If start date May 1st
  ;set genID replace-item 0 genID 14497 ;; If start date June 1st

  ifelse (modechoice = 1 or modechoice = 3)[
    crt 1 [
      
      set color blue
      set shape "circle"
      set size 4
      set xcor 0
      set ycor 0
      set label "Storage"
      set storage self
      
    ]
    
    crt 1 [
      
      set color green
      set shape "circle"
      set size 3
      set xcor -10
      set ycor 0
      set label "Solar cell farm"
      set microgen self
      set hourlygen 0
      
      ask microgen [
        create-link-with storage
      ]
    ]
  ] 
  [
    set housecounter 0
    while [housecounter < 20][
      ifelse(housecounter = 0 or housecounter = 1)[
        
        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 7 / 38 ))
        set housecounter housecounter + 1
      ]
      [
        ifelse (housecounter = 9 or housecounter = 15)[
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 3 / 38 ))
          set housecounter housecounter + 1
        ]
        [
          ifelse(housecounter = 7 or housecounter = 18)[
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 2 / 38 ))
            set housecounter housecounter + 1
          ]
          [
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (totalstoredenergy * 1 / 38 ))
            set housecounter housecounter + 1
          ]
        ]
      ]
    ]
  ]
  
  sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
  set hourlygen sql:fetch-row
  ;print hourlygen
  set dailygen replace-item 0 dailygen read-from-string item 0 hourlygen
  ;print dailygen
  
end

to setup-inital-houses
  
  set totaldaycons 0
  set lastdayaverage 50
  
  set totalUserIDs n-values 20 [0]
  
  set peakboundaries n-values 6 [0]
  
  set hourlycons n-values initial-number-of-homes [0]
  set hourlynodecons n-values 24 [0]
  set hourlynodecons2 n-values 24 [0]
  set hourlynodecons3 n-values 24 [0]
  set hourlynodeconscounter n-values initial-number-of-homes [0]
  set totalhourlynodecons n-values initial-number-of-homes [0]
  set averagehourlynodecons n-values initial-number-of-homes [0]
  
  ;Initializing all UserIDs
  set totalUserIDs [7350049083690884 7350049084530592 7350049084529299 7350049084531155 7350049084529251 7350049084529213 7350049084531209 7350049084529565 7350049084529497 7350049084529459 7350049084529404 7350049084531339 7350049084531292 7350049084531537 7350049084531469 7350049084531346 7350049084530974 7350049084530912 7350049084530813 7350049084530745]
  
  set peakboundaries [1.203 1.198 1.240 1.244 1.292 1.292]
  set peakboundaries1 [1.083 1.078 1.116 1.120 1.163 1.163]
  set peakboundaries2 [0.974 0.970 1.004 1.008 1.047 1.047]
  set peakboundaries3 [0.877 0.873 0.904 0.907 0.942 0.942]
  set peakboundaries4 [0.789 0.786 0.814 0.816 0.848 0.848]
  set peakboundaries5 [0.710 0.707 0.732 0.735 0.763 0.763]
  set peakboundaries6 [0.639 0.637 0.659 0.661 0.687 0.687]
  set peakboundaries7 [0.575 0.573 0.593 0.595 0.618 0.618]
  set peakboundaries8 [0.518 0.516 0.534 0.536 0.556 0.556]
  
  set currentpeakboundary (item 0 peakboundaries)
  set index 0 ;; for position in boundary lists based on month
  
  set currentID n-values initial-number-of-homes [0]
  set currentUserID n-values 1 [0]
  set test n-values 1 [0]
  
  set totalhourcons n-values 24 [0]
  set totalhourcounter n-values 24 [0]
  
  set node-daily-cons n-values 20 [0]
  set node-average-daily n-values 20 [3]
  set macrogrid-list n-values 20 [0]
  set current-cons-list n-values 20 [0]
  
  ;Initialize measurement ID counters to save model setup-time
  ;set currentID [[42732] [4169578] [828310] [5852244] [769377] [633018] [5951536] [1547648] [1416858] [1286261] [1126079] [6261733] [6123584] [6877164] [6663728] [6297209] [5272312] [5083277] [4855812] [4608948]] ; If start Oct 2012
  
  set currentID [[44940] [4171786] [830518] [5854452] [771585] [635226] [5953744] [1549856] [1419066] [1288469] [1128287] [6263941] [6125792] [6879372] [6665936] [6299417] [5274520] [5085485] [4858020] [4611156]] ;If start Jan 2013
  
  ;set currentID [[45684] [4172530] [831262] [5855196] [772329] [635970] [5954488] [1550600] [1419810] [1289213] [1129031] [6264685] [6126536] [6880116] [6666680] [6300161] [5275264] [5086229] [4858764] [4611900]] ; If start February 2013
  
  ;set currentID [[46356] [4173202] [831934] [5855868] [773001] [636642] [5955160] [1551272] [1420482] [1289885] [1129703] [6265357] [6127208] [6880788] [6667352] [6300833] [5275936] [5086901] [4859436] [4612572]] ; If start March 2013
  
  ;set currentID [[47100] [4173946] [832678] [5856612] [773745] [637386] [5955904] [1552016] [1421226] [1290629] [1130447] [6266101] [6127952] [6881532] [6668096] [6301577] [5276680] [5087645] [4860180] [4613316]] ;; If start April 2013
  
  ;set currentID [[47820] [4174666] [833398] [5857332] [774465] [638106] [5956624] [1552736] [1421946] [1291349] [1131167] [6266821] [6128672] [6882252] [6668816] [6302297] [5277400] [5088365] [4860900] [4614036]] ;; If start May 2013
  
  ;set currentID [[48564] [4175410] [834142] [5858076] [775209] [638850] [5957368] [1553480] [1422690] [1292093] [1131911] [6267565] [6129416] [6882996] [6669560] [6303041] [5278144] [5089109] [4861644] [4614780]] ;; If start June 2013
  
  set counter 0
  while [counter < initial-number-of-homes][
    
    set hourlynodeconscounter replace-item counter hourlynodeconscounter hourlynodecons
    set totalhourlynodecons replace-item counter totalhourlynodecons hourlynodecons2
    set averagehourlynodecons replace-item counter averagehourlynodecons hourlynodecons3
    
    set counter counter + 1
  ]

  set hourcounter 0

  set housecounter 0
  
  ifelse(modechoice = 1 or modechoice = 3)[
    while [housecounter < initial-number-of-homes][
      
      make-node
      set housecounter housecounter + 1
      
    ]
  ]
  [
    set counter 0
    while [housecounter < initial-number-of-homes][
      
      make-node-pref
      set housecounter housecounter + 1
      
    ]
  ]
  
  set totalhourcounter replace-item hourcounter totalhourcounter (initial-number-of-homes)
  
  set hourcounter 0
  
end

to make-node
    crt 1
    [
      set color red
      set shape "circle"
      set xcor 0
      set ycor random 10
      set currentUserID replace-item 0 currentUserID (item housecounter totalUserIDs)
      
      ;The initial measurement IDs of all households is preset to reduce model setup time
      ;sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000 AND Method = 'ActivePlus'" (currentUserID)
      ;set currentID replace-item housecounter currentID (sql:fetch-row)
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)
      
      set hourlynodecons replace-item 0 hourlynodecons (item housecounter item 0 totalhourlynodecons + item 0 item housecounter hourlycons)
      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons
      
      set hourlynodecons2 replace-item 0 hourlynodecons (item housecounter item 0 hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      set hourlynodecons3 replace-item 0 hourlynodecons ( (item 0 item housecounter totalhourlynodecons) / (item 0 item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3
      
      
      if (choose-house-ID-for-plot1 = item housecounter totalUserIDs)[
        set plot1var housecounter 
        set plot1 item housecounter hourlycons
        set plot3 item housecounter item hourcounter averagehourlynodecons
      ]
      
      if (choose-house-ID-for-plot2 = item housecounter totalUserIDs)[
        set plot2var housecounter 
        set plot2 item 0 item housecounter hourlycons
        set plot4 item housecounter item hourcounter averagehourlynodecons
      ]
      create-link-with storage [ set color grey ]
      fd 6
      
    ]
  
end

to make-node-pref

  crt 1
    [
      set color red
      set shape "circle"
      ;set xcor 0
      ;set ycor random 10
      set currentUserID replace-item 0 currentUserID (item housecounter totalUserIDs)
      
      ;The initial measurement IDs of all households is preset to reduce model setup time
      ;sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000 AND Method = 'ActivePlus'" (currentUserID)
      ;set currentID replace-item housecounter currentID (sql:fetch-row)
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      ;set label currentUserID
      
      set node-daily-cons replace-item housecounter node-daily-cons (item housecounter node-daily-cons + item 0 item housecounter hourlycons)
      ;print node-daily-cons
      
      set current-cons-list replace-item housecounter current-cons-list (item 0 item housecounter hourlycons)
      set testplot item 2 current-cons-list
      
      set macrogrid-list replace-item housecounter macrogrid-list (item 0 item housecounter hourlycons)
      ;print macrogrid-list     
      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)
      ;print totalhourcons
      
      set hourlynodecons replace-item 0 hourlynodecons (item housecounter item 0 totalhourlynodecons + item 0 item housecounter hourlycons)
      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons
      ;print totalhourlynodecons
      
      set hourlynodecons2 replace-item 0 hourlynodecons (item housecounter item 0 hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      ;print hourlynodeconscounter
      
      set hourlynodecons3 replace-item 0 hourlynodecons ( (item 0 item housecounter totalhourlynodecons) / (item 0 item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3
      ;print averagehourlynodecons
      
      set hourcounter 1
      
      if (choose-house-ID-for-plot1 = item housecounter totalUserIDs)[
        set plot1var housecounter 
        set plot1 item housecounter hourlycons
        set plot3 item housecounter item hourcounter averagehourlynodecons
      ]
      
      if (choose-house-ID-for-plot2 = item housecounter totalUserIDs)[
        set plot2var housecounter 
        set plot2 item 0 item housecounter hourlycons
        set plot4 item housecounter item hourcounter averagehourlynodecons
      ]
      
      ifelse(housecounter = 0)[
        set first-node self
        set size 6
        set xcor -5
        set ycor 0
      ]
      [
        ifelse(housecounter = 1)[
          create-dirlink-from first-node [ set color grey ]
          create-dirlink-to first-node [ set color grey ]
          set second-node self
          set size 6
          set xcor 5
          set ycor 0
        ]
        [
          ifelse(housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6)[
            create-dirlink-from first-node [ set color grey ]
            create-dirlink-to first-node [ set color grey ]
            set size 1
            ifelse(housecounter = 2)[
              set xcor -1
              set ycor -5
            ]
            [
              ifelse(housecounter = 3)[
                set xcor -6
                set ycor -6
              ]
              [
                ifelse(housecounter = 4)[
                  set xcor -11
                  set ycor -2
                ]
                [
                  ifelse(housecounter = 5)[
                    set xcor -12
                    set ycor 4
                  ]
                  [
                    set xcor 0
                    set ycor 4
                  ]
                ]
              ]
            ]
          ]
          [
            ifelse(housecounter = 7)[
              create-dirlink-to first-node [ set color grey ]
              create-dirlink-from first-node [ set color grey ]
              set size 2
              set third-node self
              set xcor -5
              set ycor 7
            ]
            [
              ifelse(housecounter = 8)[
                create-dirlink-from third-node [ set color grey ]
                create-dirlink-to third-node [ set color grey ]
                set size 1
                set xcor -6
                set ycor 10
              ]
              [ 
                ifelse(housecounter = 9)[
                  create-dirlink-from second-node [ set color grey ]
                  create-dirlink-to second-node [ set color grey ]
                  set size 3
                  set fourth-node self
                  set xcor 6
                  set ycor 6
                ]
                [
                  ifelse(housecounter = 10 or housecounter = 11)[
                    create-dirlink-from fourth-node [ set color grey ]
                    create-dirlink-to fourth-node [ set color grey ]
                    set size 1
                    ifelse(housecounter = 10)[
                      set xcor 8
                      set ycor 9
                    ]
                    [
                      set xcor 4
                      set ycor 9
                    ]
                  ]
                  [
                    ifelse(housecounter = 12 or housecounter = 13 or housecounter = 14)[
                      create-dirlink-from second-node [ set color grey ]
                      create-dirlink-to second-node [ set color grey ]
                      set size 1
                      ifelse(housecounter = 12)[
                        set xcor 11
                        set ycor 2
                      ]
                      [
                        ifelse(housecounter = 13)[
                          set xcor 12
                          set ycor 0
                        ]
                        [
                          set xcor 11
                          set ycor -2
                        ]
                      ]
                      
                    ]
                    [
                      ifelse(housecounter = 15)[
                        create-dirlink-from second-node [ set color grey ]
                        create-dirlink-to second-node [ set color grey ]

                        set size 3
                        set fifth-node self
                        set xcor 4
                        set ycor -7
                      ]
                      [
                        ifelse(housecounter = 16 or housecounter = 17)[
                          create-dirlink-from fifth-node [ set color grey ]
                          create-dirlink-to fifth-node [ set color grey ]
                          set size 1
                          ifelse(housecounter = 16)[
                            set xcor 3
                            set ycor -10
                          ]
                          [
                            set xcor 5
                            set ycor -10
                          ]
                        ]
                        [
                          ifelse(housecounter = 18)[
                            create-dirlink-from second-node [ set color grey ]
                            create-dirlink-to second-node [ set color grey ]
                            set size 2
                            set sixth-node self
                            set xcor 0
                            set ycor -7
                          ]
                          [
                            ifelse(housecounter = 19)[
                              create-dirlink-from sixth-node [ set color grey ]
                              create-dirlink-to sixth-node [ set color grey ]
                              set size 1
                              set xcor -3
                              set ycor -8
                            ]
                            [
                              print "Error: housecounter > number of homes"
                            ]
                          ]
                        ]
                      ] 
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
      
    ]

end

to setup-initial-date-and-time
  sql:exec-query "SELECT ID FROM consumption WHERE UserID = ? AND Date = '2013-01-01' AND Time = 000000" [7350049083690884]
  set IDcounter sql:fetch-row
  
  sql:exec-query "SELECT Date FROM consumption WHERE ID = ?" (IDcounter)
  set date sql:fetch-row
  sql:exec-query "SELECT Time FROM consumption WHERE ID = ?" (IDcounter)
  set time sql:fetch-row
  
end

to go
  if ticks >= (number-of-days-for-simulation * 24 - 1) [stop]
  
  update-consumption
  update-total-consumption
  update-date-and-time
  update-generation
  
  tick
end

to update-date-and-time
  set IDcounter replace-item 0 IDcounter (item 0 IDcounter + 1)
  sql:exec-query "SELECT Date FROM consumption WHERE ID = ?" (IDcounter)
  set date sql:fetch-row
  
  set month item 6 item 0 date
  if (month != prevmonth)[
    set prevmonth month
    set index read-from-string month
    set index index - 1
    set currentpeakboundary (item index peakboundaries)
  ]

  
  sql:exec-query "SELECT Time FROM consumption WHERE ID = ?" (IDcounter)
  set time sql:fetch-row
  
end

to update-consumption
  
    set housecounter 0
    let temp n-values 1 [0]
    let temp2 n-values 1 [0]
  
  while [housecounter < initial-number-of-homes][
      
      set temp replace-item 0 temp (item housecounter currentID)
      set temp replace-item 0 temp (item 0 item 0 temp + 1)
      set currentID replace-item housecounter currentID temp
      
      
      sql:exec-query "SELECT HourlyConsumption FROM consumption WHERE ID = ? AND Method = 'ActivePlus'" (item housecounter currentID)
      set hourlycons replace-item housecounter hourlycons (sql:fetch-row)
      
      set node-daily-cons replace-item housecounter node-daily-cons (item housecounter node-daily-cons + item 0 item housecounter hourlycons)

      
      set totalhourcons replace-item hourcounter totalhourcons (item hourcounter totalhourcons + item 0 item housecounter hourlycons)

      
      set hourlynodecons (item housecounter totalhourlynodecons)

      set hourlynodecons replace-item hourcounter hourlynodecons (item hourcounter item housecounter totalhourlynodecons + item 0 item housecounter hourlycons)

      set totalhourlynodecons replace-item housecounter totalhourlynodecons hourlynodecons
      
      set dailycons dailycons + item 0 item housecounter hourlycons

     
      set hourlynodecons2 (item housecounter hourlynodeconscounter)
      set hourlynodecons2 replace-item hourcounter hourlynodecons2 (item hourcounter item housecounter hourlynodeconscounter + 1)
      set hourlynodeconscounter replace-item housecounter hourlynodeconscounter hourlynodecons2
      
      
      set hourlynodecons3 (item housecounter averagehourlynodecons)
      set hourlynodecons3 replace-item hourcounter hourlynodecons3 ( (item hourcounter item housecounter totalhourlynodecons) / (item hourcounter item housecounter hourlynodeconscounter) )
      set averagehourlynodecons replace-item housecounter averagehourlynodecons hourlynodecons3

      
      if (plot1var = housecounter)[ 
        set plot1 item 0 item housecounter hourlycons
        set plot3 item hourcounter item housecounter averagehourlynodecons
      ]
      
      if (plot2var = housecounter)[
        set plot2 item 0 item housecounter hourlycons
        set plot4 item hourcounter item housecounter averagehourlynodecons
      ]
      
      set housecounter housecounter + 1
  ]
  
  set totalhourcounter replace-item hourcounter totalhourcounter (item hourcounter totalhourcounter + initial-number-of-homes)
    
    
  set housecounter 0
  set totalcons 0
  set macrogrid 0
  set total-cons-dist-gen 0
  
  while[housecounter < initial-number-of-homes][
    
    set temp2 (item housecounter hourlycons)
    set totalcons totalcons + (item 0 temp2)
    
    set housecounter housecounter + 1
  ]  

  ifelse(modechoice = 1)[
    peakshaving-solar-farm
  ]
  [
    ifelse(modechoice = 2)[
      peakshaving-dist-gen
    ]
    [
      island-mode ;;No peakshaving
    ]
  ]


  
  set averagecons totalcons / initial-number-of-homes
  
  set totaldaycons totaldaycons + totalcons
end

to peakshaving-solar-farm
  
  ifelse (totalstoredenergy > 1000)[
    
    set currentpeakboundary (item index peakboundaries8)
    set need2 totalstoredenergy - 1000
    set totalstoredenergy totalstoredenergy - need2
    
  ]
  [
    set need2 0
    ifelse (totalstoredenergy > 900)[
      
      set currentpeakboundary (item index peakboundaries8)
      
    ]
    [
      
      ifelse (totalstoredenergy > 800)[
        
        set currentpeakboundary (item index peakboundaries7)
        
      ]
      [
        
        ifelse (totalstoredenergy > 700)[
          
          set currentpeakboundary (item index peakboundaries6)
          
        ]
        [
          
          ifelse (totalstoredenergy > 600)[
            
            set currentpeakboundary (item index peakboundaries5)
            
          ]
          [
            
            ifelse (totalstoredenergy > 500)[
              
              set currentpeakboundary (item index peakboundaries4)
              
            ]
            [
              ifelse (totalstoredenergy > 400)[
                
                set currentpeakboundary (item index peakboundaries3)
                
              ]
              [
                ifelse (totalstoredenergy > 300)[
                  
                  set currentpeakboundary (item index peakboundaries2)
                  
                ]
                [
                  ifelse (totalstoredenergy > 200)[
                    
                    set currentpeakboundary (item index peakboundaries1)
                    
                  ]
                  [
                    set currentpeakboundary (item index peakboundaries)
                  ]
                ]
              ] 
            ]
          ]
        ]
      ]
    ]
  ]
  
  
  
  ifelse (totalcons > currentpeakboundary * lastdayaverage)[
    
    set need totalcons - (currentpeakboundary * lastdayaverage)
    
    ifelse (totalstoredenergy > 200 and totalcons < (item index peakboundaries) * lastdayaverage )[
      
      ifelse (need > totalstoredenergy - 200)[
        
        set need totalstoredenergy - 200
        set totalstoredenergy totalstoredenergy - need
        set macrogrid totalcons - need
        
      ]
      [
        
        set totalstoredenergy totalstoredenergy - need
        set need need + need2
        set macrogrid totalcons - need 
        
      ]
    ]  
    [ 
      set need totalcons - (currentpeakboundary * lastdayaverage)
      
      ifelse (totalstoredenergy > 0)[
        
        ifelse (need > totalstoredenergy)[
          set need totalstoredenergy
          set totalstoredenergy totalstoredenergy - need
          set macrogrid totalcons - need
          
        ]
        [
          set totalstoredenergy totalstoredenergy - need
          set need need + need2
          set macrogrid totalcons - need
        ]
        
      ]
      [
        set macrogrid totalcons
        set need 0
      ]
      
    ]
  ]
  [
    set macrogrid totalcons
    set need 0
  ]
  
end

to peakshaving-dist-gen
  
  set need-dist-gen 0
  set housecounter 0
  set currentpeakboundary (item index peakboundaries)
  
  ifelse (storagestatus > 90)[
    
    set currentpeakboundary (item index peakboundaries8)
    
  ]
  [
    
    ifelse (storagestatus > 80)[
      
      set currentpeakboundary (item index peakboundaries7)
      
    ]
    [
      
      ifelse (storagestatus > 70)[
        
        set currentpeakboundary (item index peakboundaries6)
        
      ]
      [
        
        ifelse (storagestatus > 60)[
          
          set currentpeakboundary (item index peakboundaries5)
          
        ]
        [
          
          ifelse (storagestatus > 50)[
            
            set currentpeakboundary (item index peakboundaries4)
            
          ]
          [
            ifelse (storagestatus > 40)[
              
              set currentpeakboundary (item index peakboundaries3)
              
            ]
            [
              ifelse (storagestatus > 30)[
                
                set currentpeakboundary (item index peakboundaries2)
                
              ]
              [
                ifelse (storagestatus > 20)[
                  
                  set currentpeakboundary (item index peakboundaries1)
                  
                ]
                [
                  set currentpeakboundary (item index peakboundaries)
                ]
              ]
            ] 
          ]
        ]
      ]
    ]
  ]
  
  
  while [housecounter < initial-number-of-homes][
    set current-cons-list replace-item housecounter current-cons-list (item 0 item housecounter hourlycons)
    set testplot item 2 current-cons-list 
    ifelse(housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6)[
      ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
        set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
        ifelse(need-dist-gen < item housecounter storedenergylist)[
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
        ]
        [
          ifelse(need-dist-gen < item 0 storedenergylist)[
            set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
          ]
          [
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
          ]
        ]
      ]
      [
        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
        ;;no peak shaving needed
      ]
      set testplot2 item 2 macrogrid-list
      set housecounter housecounter + 1
    ]
    [
      ifelse(housecounter = 7)[
        ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
          set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
          ifelse(need-dist-gen < item housecounter storedenergylist)[
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
          ]
          [
            ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
            ifelse(need-dist-gen < item 0 storedenergylist)[
              set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
            ]
            [
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
            ]
          ]
        ]
        [
        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
        ;;no peak shaving
        ]
        set housecounter housecounter + 1
      ]
      [
        ifelse(housecounter = 8)[
          ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
            set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
            ifelse(need-dist-gen < item housecounter storedenergylist)[
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
            ]
            [
              ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
              ifelse(need-dist-gen < item 7 storedenergylist)[
                set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist - need-dist-gen)
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
              ]
              [
                ifelse(need-dist-gen < item 0 storedenergylist)[
                  set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
                  set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist + need-dist-gen)
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                ]
              ]
            ]
          ]
          [
            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
            ;;no peak shaving needed
          ]
          set housecounter housecounter + 1
        ]
        [
          ifelse(housecounter = 0)[
            ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
              set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
              ifelse(need-dist-gen < item housecounter storedenergylist)[
                set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
              ]
              [
                ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                ifelse(need-dist-gen < item 1 storedenergylist)[
                  set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                ]
              ]
            ]
            [
              set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
              ;;no peak shaving needed
            ]
            set housecounter housecounter + 1
          ]
          [
            ifelse(housecounter = 9 or housecounter = 12 or housecounter = 13 or housecounter = 14 or housecounter = 15 or housecounter = 18)[
              ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                ifelse(need-dist-gen < item housecounter storedenergylist)[
                  set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                ]
                [
                  ifelse(need-dist-gen < item 1 storedenergylist)[
                    set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                  ]
                  [
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                  ]
                ]
              ]
              [
                set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                ;;no peak shaving needed
              ]
              set housecounter housecounter + 1
            ]
            [
              ifelse(housecounter = 10 or housecounter = 11)[
                ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                  set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                  ifelse(need-dist-gen < item housecounter storedenergylist)[
                    set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                  ]
                  [
                    ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                    ifelse(need-dist-gen < item 9 storedenergylist)[
                      set storedenergylist replace-item 9 storedenergylist (item 9 storedenergylist - need-dist-gen)
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                    ]
                    [
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                    ]
                  ]
                ]
                [
                  set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                  ;;no peak shaving needed
                ]
                set housecounter housecounter + 1
              ]
              [
                ifelse(housecounter = 16 or housecounter = 17)[
                  ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                    set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                    ifelse(need-dist-gen < item housecounter storedenergylist)[
                      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                    ]
                    [
                      ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                      ifelse(need-dist-gen < item 15 storedenergylist)[
                        set storedenergylist replace-item 15 storedenergylist (item 15 storedenergylist - need-dist-gen)
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                      ]
                      [
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                      ]
                    ]
                  ]
                  [
                    set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                    ;;no peak shaving needed
                  ]
                  set housecounter housecounter + 1 
                ]
                [
                  ifelse(housecounter = 19)[
                    ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                      set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                      ifelse(need-dist-gen < item housecounter storedenergylist)[
                        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                      ]
                      [
                        ;;set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                        ifelse(need-dist-gen < item 18 storedenergylist)[
                          set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist - need-dist-gen)
                          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                        ]
                        [
                          ifelse(need-dist-gen < item 1 storedenergylist)[
                            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - need-dist-gen)
                            set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist + need-dist-gen)
                          ]
                          [
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                          ]
                        ]
                      ]
                    ]
                    [
                      set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                      ;;no peak shaving
                    ]
                    set housecounter housecounter + 1
                  ]
                  [
                    ifelse(housecounter = 1)[
                      ifelse(item housecounter current-cons-list > ( (item housecounter node-average-daily) * currentpeakboundary) )[
                        set need-dist-gen (item housecounter current-cons-list) - ((item housecounter node-average-daily) * currentpeakboundary)
                        ifelse(need-dist-gen < item housecounter storedenergylist)[
                          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - need-dist-gen)
                          set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                        ]
                        [
                          ifelse(need-dist-gen < item 0 storedenergylist)[
                            set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - need-dist-gen)
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list - need-dist-gen)
                          ]
                          [
                            set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list) ;; Nothing left
                          ]
                        ]
                      ]
                      [
                        set macrogrid-list replace-item housecounter macrogrid-list (item housecounter current-cons-list)
                        ;;no peak shaving
                      ]
                      set housecounter housecounter + 1
                    ]
                    [
                      print "Error: housecounter > number of homes"
                      print housecounter
                      ;set housecounter housecounter + 1
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
    ]
  ]
  set housecounter 0
  while [housecounter < initial-number-of-homes][
    set macrogrid macrogrid + (item housecounter macrogrid-list)
    set total-cons-dist-gen total-cons-dist-gen + (item housecounter current-cons-list)
    set housecounter housecounter + 1
  ]
  
  set node-macrogrid-cons1 item plot1var macrogrid-list
  set node-macrogrid-cons2 item plot2var macrogrid-list
  
end

to island-mode
  
  set macrogrid totalcons
  
  ifelse (totalstoredenergy > 1000 and External-supply)[
    
    set currentpeakboundary (item index peakboundaries)
    set need totalstoredenergy - 1000
    set totalstoredenergy totalstoredenergy - need
    set macrogrid macrogrid - need
    
  ]
  [ 
    ifelse (not External-supply)[
      set macrogrid 0
      ifelse (totalstoredenergy > totalcons)[
        set totalstoredenergy totalstoredenergy - totalcons
        set microgrid totalcons
      ]
      [
        ifelse (totalstoredenergy > 10)[
          set need totalstoredenergy
          set totalstoredenergy totalstoredenergy - need
          set microgrid need
        ]
        [
          set microgrid 0
        ]
      ]
    ]
    [
      set macrogrid macrogrid
      set microgrid 0
    ]
  ]
  
end

to update-total-consumption
  set plottotal (item hourcounter totalhourcons) / (item hourcounter totalhourcounter)
  set plottotal2 (item hourcounter totalhourcons)
  
  ifelse (hourcounter = 23)[
    set hourcounter 0
    
    set dailygen n-values 24 [0]
    set dailycons 0  
    
    ifelse(modechoice = 1)[
      set daily-need daily-need + need
    ]
    [
      ifelse(modechoice = 2)[
        set daily-need daily-need + (total-cons-dist-gen - macrogrid)
      ]
      [
        ;;Do nothing
      ]
    ]
    
    
    if (daily-need > max-daily)[
      set max-daily daily-need      
    ]
    
    set daily-need 0
    
    if(modechoice = 2)[
      
      set housecounter 0
      while [housecounter < initial-number-of-homes][
        
        set node-average-daily replace-item housecounter node-average-daily (item housecounter node-daily-cons / 24)
        set node-daily-cons replace-item housecounter node-daily-cons 0
        set housecounter housecounter + 1
        
      ]
    ]

    set lastdayaverage totaldaycons / 24
    set totaldaycons 0
  ]
  [
    
    ifelse(modechoice = 1)[
      set daily-need daily-need + need
    ]
    [
      ifelse(modechoice = 2)[
        set daily-need daily-need + (total-cons-dist-gen - macrogrid)
      ]
      [
        ;;Do nothing
      ]
    ]
    set hourcounter hourcounter + 1
  ]
  
end

to update-generation
  
  ifelse(modechoice = 1 or modechoice = 3)[
    generation-solar-farm-or-island-mode
  ]
  [
    generation-dist-gen-mode
  ]
  

end

to generation-solar-farm-or-island-mode
  
  repeat 4[
    set genID replace-item 0 genID (item 0 genID + 1)
    sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
    set hourlygen sql:fetch-row
    set dailygen replace-item hourcounter dailygen (item hourcounter dailygen + read-from-string item 0 hourlygen)
    set before-discharge-loss read-from-string item 0 hourlygen
    
    ;;Updating storage status and accounting for 10 % discharge loss
    set totalstoredenergy totalstoredenergy + (before-discharge-loss * 0.9)
    if(totalstoredenergy > max-stored and index = 0)[
      set max-stored totalstoredenergy
    ]
    set storagestatus totalstoredenergy / 10
    set plotgen item hourcounter dailygen
  ]
  
end

to generation-dist-gen-mode
  
  repeat 4[
    set genID replace-item 0 genID (item 0 genID + 1)
    ;print genID
    sql:exec-query "SELECT CorrectedUpscaledMeasurementMW FROM generationjanfebmaraprmayjun2013 WHERE ID = ?" (genID)
    set hourlygen sql:fetch-row
    ;print hourlygen
    set dailygen replace-item hourcounter dailygen (item hourcounter dailygen + read-from-string item 0 hourlygen)
    ;set totalstoredenergy totalstoredenergy + read-from-string item 0 hourlygen
    ;set storagestatus totalstoredenergy / 10
    set plotgen item hourcounter dailygen
    ;print dailygen
  ]
  
  set housecounter 0
  set storage-now 0
  set surplus 0
  while [housecounter < 20][
    ifelse(housecounter = 0 or housecounter = 1)[
      
      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 7 / 38 ) * 0.9)
      ;set housecounter housecounter + 1
      ifelse(housecounter = 1 and (item 0 storedenergylist > item 1 storedenergylist))[
        set surplus (item 0 storedenergylist) - (item 1 storedenergylist)
        set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist - surplus)
        set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus / 2)
        set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus / 2)
      ]
      [
        ifelse(housecounter = 1 and (item 1 storedenergylist > item 0 storedenergylist))[
          set surplus (item 1 storedenergylist) - (item 0 storedenergylist)
          set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist - surplus)
          set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus / 2)
          set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus / 2)        
        ]
        [
          
        ]
      ]
    ]
    [
      ifelse(housecounter = 7 or housecounter = 18)[
        
        set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 3 / 38 ) * 0.9)
        ;set housecounter housecounter + 1
        ifelse(housecounter = 7 and (item housecounter storedenergylist > 20))[
          set surplus (item housecounter storedenergylist) - 20
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
          set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus) 
        ]
        [
          if(housecounter = 18 and (item housecounter storedenergylist > 20))[
            set surplus (item housecounter storedenergylist) - 20
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus) 
          ]
        ]
      ]
      [
        ifelse(housecounter = 9 or housecounter = 15)[
          
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 2 / 38 ) * 0.9)
          ;set housecounter housecounter + 1
          ifelse(housecounter = 9 and (item housecounter storedenergylist > 30))[
            set surplus (item housecounter storedenergylist) - 30
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus)
          ]
          [
            if(housecounter = 15 and (item housecounter storedenergylist > 30))[
              set surplus (item housecounter storedenergylist) - 30
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
              set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus) 
            ]
          ]
        ]
        [
          set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist + (item hourcounter dailygen * 1 / 38 ) * 0.9)
          ;set housecounter housecounter + 1
          ifelse((housecounter = 11 or housecounter = 10) and (item housecounter storedenergylist > 10))[
            set surplus (item housecounter storedenergylist) - 10
            set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
            set storedenergylist replace-item 9 storedenergylist (item 9 storedenergylist + surplus)
          ]
          [
            ifelse((housecounter = 12 or housecounter = 13 or housecounter = 14) and (item housecounter storedenergylist > 10))[
              set surplus (item housecounter storedenergylist) - 10
              set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
              set storedenergylist replace-item 1 storedenergylist (item 1 storedenergylist + surplus)                
            ]
            [
              ifelse((housecounter = 16 or housecounter = 17) and (item housecounter storedenergylist > 10))[
                set surplus (item housecounter storedenergylist) - 10
                set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                set storedenergylist replace-item 15 storedenergylist (item 15 storedenergylist + surplus) 
              ]
              [
                ifelse(housecounter = 19 and (item housecounter storedenergylist > 10))[
                  set surplus (item housecounter storedenergylist) - 10
                  set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                  set storedenergylist replace-item 18 storedenergylist (item 18 storedenergylist + surplus) 
                ]
                [
                  ifelse((housecounter = 2 or housecounter = 3 or housecounter = 4 or housecounter = 5 or housecounter = 6) and (item housecounter storedenergylist > 10))[
                    set surplus (item housecounter storedenergylist) - 10
                    set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                    set storedenergylist replace-item 0 storedenergylist (item 0 storedenergylist + surplus) 
                  ]
                  [
                    ifelse(housecounter = 8 and (item housecounter storedenergylist > 10))[
                      set surplus (item housecounter storedenergylist) - 10
                      set storedenergylist replace-item housecounter storedenergylist (item housecounter storedenergylist - surplus)
                      set storedenergylist replace-item 7 storedenergylist (item 7 storedenergylist + surplus)
                    ]
                    [
                      ;;Do nothing 
                    ]
                  ]
                ]
              ]
            ]
          ]
        ]
      ]
    ]
    set storage-now storage-now + (item housecounter storedenergylist)
    set housecounter housecounter + 1 
  ]
  
set totalstoredenergy storage-now
set storagestatus totalstoredenergy / 10

set node-stored1 item plot1var storedenergylist
set node-stored2 item plot2var storedenergylist

  
end