'''plotConsumptionWeekDaysJanFebMar2013.py - This script extracts and plots the total consumption pattern on week days of 10 households in January, February and March 2013'''

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

maxID = 0
prevID = 0
cons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

count2 = 0

#Get max measurement ID in database with ActivePlus
cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")

for row in cur.fetchall():
    print(maxID)
    maxID = row[0]
    print(maxID)
    
IDcount = 0
prevID = 7350049083690884 #7350049083691225 #7350049083690884 #7350049083690839
IDs = [7350049083690884,7350049084530592,7350049084529299,7350049084531155,7350049084529251,7350049084529213,7350049084531209,7350049084529565,7350049084529497,7350049084529459]
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]


for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-01-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        #print "ID = %d" % ID
    
    for day in range (1,32):
        if (day !=5 and day !=6 and day !=12 and day !=13 and day !=19 and day !=20 and day !=26 and day != 27):
            for hour in range(0,24):
                cur.execute("SELECT `Date` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    date = row[0]
                cur.execute("SELECT `Time` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    time = row[0]
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    print "%s; %s; %s; %s;" % (IDs[IDcount], date, time, row[0])
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1
                ID = ID + 1
        else:
            ID = ID + 24 # Skip weekend


for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-02-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,29):
        if (day !=2 and day !=3 and day !=9 and day !=10 and day !=16 and day !=17 and day !=23 and day != 24):
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skipper weekend"
print cons
print howmany

for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-03-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,30):
        if (day !=2 and day !=3 and day !=9 and day !=10 and day !=16 and day !=17 and day !=23 and day != 24):
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skipper weekend"
print cons
print howmany

for hour in range(0,24):
    cons[hour] = cons[hour] / howmany[hour]

plt.plot(x,cons)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Consumption [kWh]")
plt.xlabel("Time [hours]")
#plt.axis([0,23,1300,2100]) 
plt.axis([0,23,2,3.5])
plt.grid()
plt.savefig('test.png')
plt.show()

cur.close()
conn.close()