'''plotConsumptionWeekendsJanFebMar2013.py - This script extracts and plots the aggregated weekend consumption of the January, February and March 2013'''

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

maxID = 0
prevID = 0
cons = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
howmany = [0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

count2 = 0

#Get max measurement ID in database with ActivePlus
cur.execute("SELECT MAX(`ID`) FROM `consumption` WHERE `Method`='ActivePlus'")

for row in cur.fetchall():
    print(maxID)
    maxID = row[0]
    print(maxID)
    
IDcount = 0
prevID = 7350049083690884 #7350049083691225 #7350049083690884 #7350049083690839
IDs = [7350049083690884,7350049084530592,7350049084529299,7350049084531155,7350049084529251,7350049084529213,7350049084531209,7350049084529565,7350049084529497,7350049084529459] #chosen households
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23] # hours (for plotting x axis)


for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-01-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID
    
    for day in range (1,32):
        if (day ==5 or day ==6 or day ==12 or day ==13 or day ==19 or day ==20 or day ==26 or day == 27): #excluding weekdays
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip week days"
print cons
print howmany

for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-02-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,29):
        if (day ==2 or day ==3 or day ==9 or day ==10 or day ==16 or day ==17 or day ==23 or day == 24):
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip week days"
print cons
print howmany

for IDcount in range(0,10):
    prevID = IDs[IDcount]
    cur.execute("SELECT `ID` FROM `consumption` WHERE `UserID` = %s AND `Date` = '2013-03-01' AND `Time` = '00:00:00' AND `Method`= 'ActivePlus'", prevID)
    for row in cur.fetchall():
        ID = row[0]
        print "ID = %d" % ID

    for day in range (1,32):
        if (day ==2 or day ==3 or day ==9 or day ==10 or day ==16 or day ==17 or day ==23 or day == 24 or day ==30 or day ==31):
            for hour in range(0,24):
                cur.execute("SELECT `HourlyConsumption` FROM `consumption` WHERE `ID` = %s", ID)
                for row in cur.fetchall():
                    cons[hour] = cons[hour] + row[0]
                    howmany[hour] = howmany[hour] + 1       
                ID = ID + 1
            print "day = %d" % day
        else:
            ID = ID + 24 # Skip weekend
            print "Skip week days"
print cons
print howmany

for hour in range(0,24):
    cons[hour] = cons[hour] / howmany[hour]

plt.plot(x,cons)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Consumption [kWh]")
plt.xlabel("Time [hours]")
#plt.axis([0,23,550,850])
plt.axis([0,23,2,3.5])
plt.grid()
plt.savefig('test.png')
plt.show()

cur.close()
conn.close()