'''plotGenerationOneMonth.py - This script plots one month of solar energy generation'''

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

print("Imports OK")

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

IDcounter = 1
hour = 0
gen = [0] * 24
gen2 = [0] * 24
gen3 = [0] * 24
howmany = [0] * 24

x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]


cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
for row in cur.fetchall():
    gen[hour] = float(row[0])
IDcounter = IDcounter + 1
howmany[hour] = howmany[hour] + 1

for hour in range(1,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = float(row[0])
        howmany[hour] = howmany[hour] + 1
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1

print "IDcounter before rest of January = %s" % IDcounter

for day in range(0,30):
    for hour in range(0,24):
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            gen[hour] = gen[hour] + float(row[0])
            howmany[hour] = howmany[hour] + 1
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            gen[hour] = gen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            gen[hour] = gen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjanfebmaraprmayjun2013` WHERE `ID` = %s", IDcounter)
        for row in cur.fetchall():
            gen[hour] = gen[hour] + float(row[0])
        IDcounter = IDcounter + 1
        
print "IDcounter after March = %s" % IDcounter
print gen
print gen2
print gen3


#If average    
#for hour in range(0,24):
#    gen[hour] = gen[hour] / howmany[hour]
#    gen2[hour] = gen2[hour] / howmany2[hour]
#    gen3[hour] = gen3[hour] / howmany3[hour]


cur.close()
conn.close()

print("Disconnect OK")

plt.plot(x,gen)
plt.plot(x,gen2)
plt.plot(x,gen3)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Generation [MWh]")
plt.xlabel("Time [hours]")
plt.axis([0,23,0,14])
plt.grid()
plt.savefig('test.png')
plt.show()