'''solarGeneartionOnFourConsecutiveDays.py - Solar energy generation on four consecutive days'''

import MySQLdb
import sys
import dateutil
import pyparsing

import matplotlib.pyplot as plt
import numpy
import re
import six

conn = MySQLdb.connect(host="localhost", # your host, usually localhost
                     user="root", # your username
                      passwd="root", # your password
                      db="demosteinkjer") # name of the data base

conn.autocommit(True)
cur = conn.cursor()

print("Connect OK")

IDcounter = 1
hour = 0
gen = [0] * 24
gen2 = [0] * 24
gen3 = [0] * 24
gen4 = [0] * 24
x = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23]

total1 = 0
total2 = 0
total3 = 0
total4 = 0

IDcounter = 2977#1

cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
for row in cur.fetchall():
    gen[hour] = float(row[0])
IDcounter = IDcounter + 1

for hour in range(1,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen[hour] = gen[hour] + float(row[0])
    IDcounter = IDcounter + 1
    

for hour in range(0,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen2[hour] = gen2[hour] + float(row[0])
    IDcounter = IDcounter + 1

for hour in range(0,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen3[hour] = float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen3[hour] = gen3[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen3[hour] = gen3[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen3[hour] = gen3[hour] + float(row[0])
    IDcounter = IDcounter + 1
    
for hour in range(0,24):
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen4[hour] = float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen4[hour] = gen4[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen4[hour] = gen4[hour] + float(row[0])
    IDcounter = IDcounter + 1
    cur.execute("SELECT `CorrectedUpscaledMeasurementMW` FROM `generationjulaugsept2013` WHERE `ID` = %s", IDcounter)
    for row in cur.fetchall():
        gen4[hour] = gen4[hour] + float(row[0])
    IDcounter = IDcounter + 1  

print gen
print gen2
print gen3
print gen4

for hour in range(0,24):
    gen[hour] = gen[hour] / 4
    gen2[hour] = gen2[hour] / 4
    gen3[hour] = gen3[hour] / 4
    gen4[hour] = gen4[hour] / 4

print gen
print gen2
print gen3
print gen4

cur.close()
conn.close()

print("Disconnect OK")

plt.plot(x,gen)
plt.plot(x,gen2)
plt.plot(x,gen3)
plt.plot(x,gen4)
plt.xticks([0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23])
plt.ylabel("Generation [MW]")
plt.xlabel("Time [hour]")
plt.axis([0,23,0,8])
plt.grid()
plt.savefig('test.png')
plt.show()
